#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
_category_constant_3 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     NET ODB SSH SSL TAG */
  /* Offset 2 gives the best switch position.  */
  switch (name[2]) {
  case 'B':
    if (name[0] == 'O' && name[1] == 'D') {
#ifdef ODB
      *iv_return = ODB;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'G':
    if (name[0] == 'T' && name[1] == 'A') {
#ifdef TAG
      *iv_return = TAG;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'H':
    if (name[0] == 'S' && name[1] == 'S') {
#ifdef SSH
      *iv_return = SSH;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (name[0] == 'S' && name[1] == 'S') {
#ifdef SSL
      *iv_return = SSL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (name[0] == 'N' && name[1] == 'E') {
#ifdef NET
      *iv_return = NET;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_category_constant_4 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     NONE TREE ZLIB */
  /* Offset 1 gives the best switch position.  */
  switch (name[1]) {
  case 'L':
    if (memEQ(name, "ZLIB", 4)) {
    /*                ^        */
#ifdef ZLIB
      *iv_return = ZLIB;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "NONE", 4)) {
    /*                ^        */
#ifdef NONE
      *iv_return = NONE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "TREE", 4)) {
    /*                ^        */
#ifdef TREE
      *iv_return = TREE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_category_constant_5 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     INDEX MERGE REGEX STASH */
  /* Offset 0 gives the best switch position.  */
  switch (*name++) {
  case 'I':
    if (memEQ(name, "NDEX", 4)) {
    /*                I          */
#ifdef INDEX
      *iv_return = INDEX;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'M':
    if (memEQ(name, "ERGE", 4)) {
    /*                M          */
#ifdef MERGE
      *iv_return = MERGE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "EGEX", 4)) {
    /*                R          */
#ifdef REGEX
      *iv_return = REGEX;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'S':
    if (memEQ(name, "TASH", 4)) {
    /*                S          */
#ifdef STASH
      *iv_return = STASH;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_category_constant_6 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     CONFIG FILTER OBJECT REBASE REVERT THREAD */
  /* Offset 4 gives the best switch position.  */
  switch (name[4]) {
  case 'A':
    if (memEQ(name, "THREAD", 6)) {
    /*                   ^       */
#ifdef THREAD
      *iv_return = THREAD;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'C':
    if (memEQ(name, "OBJECT", 6)) {
    /*                   ^       */
#ifdef OBJECT
      *iv_return = OBJECT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "FILTER", 6)) {
    /*                   ^       */
#ifdef FILTER
      *iv_return = FILTER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "CONFIG", 6)) {
    /*                   ^       */
#ifdef CONFIG
      *iv_return = CONFIG;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "REVERT", 6)) {
    /*                   ^       */
#ifdef REVERT
      *iv_return = REVERT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'S':
    if (memEQ(name, "REBASE", 6)) {
    /*                   ^       */
#ifdef REBASE
      *iv_return = REBASE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_category_constant_8 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     CALLBACK CHECKOUT DESCRIBE INTERNAL NOMEMORY */
  /* Offset 1 gives the best switch position.  */
  switch (name[1]) {
  case 'A':
    if (memEQ(name, "CALLBACK", 8)) {
    /*                ^            */
#ifdef CALLBACK
      *iv_return = CALLBACK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "DESCRIBE", 8)) {
    /*                ^            */
#ifdef DESCRIBE
      *iv_return = DESCRIBE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'H':
    if (memEQ(name, "CHECKOUT", 8)) {
    /*                ^            */
#ifdef CHECKOUT
      *iv_return = CHECKOUT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "INTERNAL", 8)) {
    /*                ^            */
#ifdef INTERNAL
      *iv_return = INTERNAL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "NOMEMORY", 8)) {
    /*                ^            */
#ifdef NOMEMORY
      *iv_return = NOMEMORY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_category_constant_9 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     FETCHHEAD REFERENCE SUBMODULE */
  /* Offset 5 gives the best switch position.  */
  switch (name[5]) {
  case 'D':
    if (memEQ(name, "SUBMODULE", 9)) {
    /*                    ^         */
#ifdef SUBMODULE
      *iv_return = SUBMODULE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "REFERENCE", 9)) {
    /*                    ^         */
#ifdef REFERENCE
      *iv_return = REFERENCE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'H':
    if (memEQ(name, "FETCHHEAD", 9)) {
    /*                    ^         */
#ifdef FETCHHEAD
      *iv_return = FETCHHEAD;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_category_constant_10 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     CHERRYPICK FILESYSTEM REPOSITORY */
  /* Offset 1 gives the best switch position.  */
  switch (name[1]) {
  case 'E':
    if (memEQ(name, "REPOSITORY", 10)) {
    /*                ^               */
#ifdef REPOSITORY
      *iv_return = REPOSITORY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'H':
    if (memEQ(name, "CHERRYPICK", 10)) {
    /*                ^               */
#ifdef CHERRYPICK
      *iv_return = CHERRYPICK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "FILESYSTEM", 10)) {
    /*                ^               */
#ifdef FILESYSTEM
      *iv_return = FILESYSTEM;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_category_constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl5.34.0 -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(CALLBACK CHECKOUT CHERRYPICK CONFIG DESCRIBE FETCHHEAD
	       FILESYSTEM FILTER INDEX INDEXER INTERNAL INVALID MERGE NET
	       NOMEMORY NONE OBJECT ODB OS REBASE REFERENCE REGEX REPOSITORY
	       REVERT SSH SSL STASH SUBMODULE TAG THREAD TREE ZLIB));

print constant_types(), "\n"; # macro defs
foreach (C_constant ("Git::Raw::Error::Category", '_category_constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("Git::Raw::Error::Category", $types);
__END__
   */

  switch (len) {
  case 2:
    if (name[0] == 'O' && name[1] == 'S') {
#ifdef OS
      *iv_return = OS;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 3:
    return _category_constant_3 (aTHX_ name, iv_return);
    break;
  case 4:
    return _category_constant_4 (aTHX_ name, iv_return);
    break;
  case 5:
    return _category_constant_5 (aTHX_ name, iv_return);
    break;
  case 6:
    return _category_constant_6 (aTHX_ name, iv_return);
    break;
  case 7:
    /* Names all of length 7.  */
    /* INDEXER INVALID */
    /* Offset 3 gives the best switch position.  */
    switch (name[3]) {
    case 'A':
      if (memEQ(name, "INVALID", 7)) {
      /*                  ^         */
#ifdef INVALID
        *iv_return = INVALID;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'E':
      if (memEQ(name, "INDEXER", 7)) {
      /*                  ^         */
#ifdef INDEXER
        *iv_return = INDEXER;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 8:
    return _category_constant_8 (aTHX_ name, iv_return);
    break;
  case 9:
    return _category_constant_9 (aTHX_ name, iv_return);
    break;
  case 10:
    return _category_constant_10 (aTHX_ name, iv_return);
    break;
  }
  return PERL_constant_NOTFOUND;
}

