#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
_error_constant_5 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     EAUTH EBUFS EPEEL ERROR USAGE */
  /* Offset 4 gives the best switch position.  */
  switch (name[4]) {
  case 'E':
    if (memEQ(name, "USAG", 4)) {
    /*                   E     */
#ifdef USAGE
      *iv_return = USAGE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'H':
    if (memEQ(name, "EAUT", 4)) {
    /*                   H     */
#ifdef EAUTH
      *iv_return = EAUTH;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "EPEE", 4)) {
    /*                   L     */
#ifdef EPEEL
      *iv_return = EPEEL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "ERRO", 4)) {
    /*                   R     */
#ifdef ERROR
      *iv_return = ERROR;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'S':
    if (memEQ(name, "EBUF", 4)) {
    /*                   S     */
#ifdef EBUFS
      *iv_return = EBUFS;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_error_constant_7 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     EEXISTS ELOCKED RESOLVE */
  /* Offset 4 gives the best switch position.  */
  switch (name[4]) {
  case 'K':
    if (memEQ(name, "ELOCKED", 7)) {
    /*                   ^        */
#ifdef ELOCKED
      *iv_return = ELOCKED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "RESOLVE", 7)) {
    /*                   ^        */
#ifdef RESOLVE
      *iv_return = RESOLVE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'S':
    if (memEQ(name, "EEXISTS", 7)) {
    /*                   ^        */
#ifdef EEXISTS
      *iv_return = EEXISTS;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_error_constant_9 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     EBAREREPO ECONFLICT EMODIFIED ENOTFOUND EUNMERGED */
  /* Offset 3 gives the best switch position.  */
  switch (name[3]) {
  case 'D':
    if (memEQ(name, "EMODIFIED", 9)) {
    /*                  ^           */
#ifdef EMODIFIED
      *iv_return = EMODIFIED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'M':
    if (memEQ(name, "EUNMERGED", 9)) {
    /*                  ^           */
#ifdef EUNMERGED
      *iv_return = EUNMERGED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ECONFLICT", 9)) {
    /*                  ^           */
#ifdef ECONFLICT
      *iv_return = ECONFLICT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "EBAREREPO", 9)) {
    /*                  ^           */
#ifdef EBAREREPO
      *iv_return = EBAREREPO;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (memEQ(name, "ENOTFOUND", 9)) {
    /*                  ^           */
#ifdef ENOTFOUND
      *iv_return = ENOTFOUND;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_error_constant_12 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ECERTIFICATE EINVALIDSPEC EUNCOMMITTED */
  /* Offset 11 gives the best switch position.  */
  switch (name[11]) {
  case 'C':
    if (memEQ(name, "EINVALIDSPE", 11)) {
    /*                          C      */
#ifdef EINVALIDSPEC
      *iv_return = EINVALIDSPEC;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'D':
    if (memEQ(name, "EUNCOMMITTE", 11)) {
    /*                          D      */
#ifdef EUNCOMMITTED
      *iv_return = EUNCOMMITTED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "ECERTIFICAT", 11)) {
    /*                          E      */
#ifdef ECERTIFICATE
      *iv_return = ECERTIFICATE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_error_constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl5.34.0 -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(ASSERT EAMBIGUOUS EAPPLIED EAUTH EBAREREPO EBUFS ECERTIFICATE
	       ECONFLICT EDIRECTORY EEOF EEXISTS EINVALID EINVALIDSPEC ELOCKED
	       EMERGECONFLICT EMODIFIED ENONFASTFORWARD ENOTFOUND EPEEL ERROR
	       EUNBORNBRANCH EUNCOMMITTED EUNMERGED OK PASSTHROUGH RESOLVE
	       USAGE));

print constant_types(), "\n"; # macro defs
foreach (C_constant ("Git::Raw::Error", '_error_constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("Git::Raw::Error", $types);
__END__
   */

  switch (len) {
  case 2:
    if (name[0] == 'O' && name[1] == 'K') {
#ifdef OK
      *iv_return = OK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 4:
    if (memEQ(name, "EEOF", 4)) {
#ifdef EEOF
      *iv_return = EEOF;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 5:
    return _error_constant_5 (aTHX_ name, iv_return);
    break;
  case 6:
    if (memEQ(name, "ASSERT", 6)) {
#ifdef ASSERT
      *iv_return = ASSERT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 7:
    return _error_constant_7 (aTHX_ name, iv_return);
    break;
  case 8:
    /* Names all of length 8.  */
    /* EAPPLIED EINVALID */
    /* Offset 2 gives the best switch position.  */
    switch (name[2]) {
    case 'N':
      if (memEQ(name, "EINVALID", 8)) {
      /*                 ^           */
#ifdef EINVALID
        *iv_return = EINVALID;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'P':
      if (memEQ(name, "EAPPLIED", 8)) {
      /*                 ^           */
#ifdef EAPPLIED
        *iv_return = EAPPLIED;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 9:
    return _error_constant_9 (aTHX_ name, iv_return);
    break;
  case 10:
    /* Names all of length 10.  */
    /* EAMBIGUOUS EDIRECTORY */
    /* Offset 6 gives the best switch position.  */
    switch (name[6]) {
    case 'T':
      if (memEQ(name, "EDIRECTORY", 10)) {
      /*                     ^          */
#ifdef EDIRECTORY
        *iv_return = EDIRECTORY;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'U':
      if (memEQ(name, "EAMBIGUOUS", 10)) {
      /*                     ^          */
#ifdef EAMBIGUOUS
        *iv_return = EAMBIGUOUS;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 11:
    if (memEQ(name, "PASSTHROUGH", 11)) {
#ifdef PASSTHROUGH
      *iv_return = PASSTHROUGH;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 12:
    return _error_constant_12 (aTHX_ name, iv_return);
    break;
  case 13:
    if (memEQ(name, "EUNBORNBRANCH", 13)) {
#ifdef EUNBORNBRANCH
      *iv_return = EUNBORNBRANCH;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 14:
    if (memEQ(name, "EMERGECONFLICT", 14)) {
#ifdef EMERGECONFLICT
      *iv_return = EMERGECONFLICT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 15:
    if (memEQ(name, "ENONFASTFORWARD", 15)) {
#ifdef ENONFASTFORWARD
      *iv_return = ENONFASTFORWARD;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

