#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
_object_constant_3 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ANY BAD TAG */
  /* Offset 0 gives the best switch position.  */
  switch (*name++) {
  case 'A':
    if (name[0] == 'N' && name[1] == 'Y') {
#ifdef ANY
      *iv_return = ANY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'B':
    if (name[0] == 'A' && name[1] == 'D') {
#ifdef BAD
      *iv_return = BAD;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (name[0] == 'A' && name[1] == 'G') {
#ifdef TAG
      *iv_return = TAG;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_object_constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl5.34.0 -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(ANY BAD BLOB COMMIT TAG TREE));

print constant_types(), "\n"; # macro defs
foreach (C_constant ("Git::Raw::Object", '_object_constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("Git::Raw::Object", $types);
__END__
   */

  switch (len) {
  case 3:
    return _object_constant_3 (aTHX_ name, iv_return);
    break;
  case 4:
    /* Names all of length 4.  */
    /* BLOB TREE */
    /* Offset 3 gives the best switch position.  */
    switch (name[3]) {
    case 'B':
      if (memEQ(name, "BLO", 3)) {
      /*                  B     */
#ifdef BLOB
        *iv_return = BLOB;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'E':
      if (memEQ(name, "TRE", 3)) {
      /*                  E     */
#ifdef TREE
        *iv_return = TREE;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 6:
    if (memEQ(name, "COMMIT", 6)) {
#ifdef COMMIT
      *iv_return = COMMIT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

