#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
_rebase_operation_constant_4 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     EDIT EXEC PICK */
  /* Offset 2 gives the best switch position.  */
  switch (name[2]) {
  case 'C':
    if (memEQ(name, "PICK", 4)) {
    /*                 ^       */
#ifdef PICK
      *iv_return = PICK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "EXEC", 4)) {
    /*                 ^       */
#ifdef EXEC
      *iv_return = EXEC;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "EDIT", 4)) {
    /*                 ^       */
#ifdef EDIT
      *iv_return = EDIT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_rebase_operation_constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl5.34.0 -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(EDIT EXEC FIXUP PICK REWORD SQUASH));

print constant_types(), "\n"; # macro defs
foreach (C_constant ("Git::Raw::Rebase::Operation", '_rebase_operation_constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("Git::Raw::Rebase::Operation", $types);
__END__
   */

  switch (len) {
  case 4:
    return _rebase_operation_constant_4 (aTHX_ name, iv_return);
    break;
  case 5:
    if (memEQ(name, "FIXUP", 5)) {
#ifdef FIXUP
      *iv_return = FIXUP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 6:
    /* Names all of length 6.  */
    /* REWORD SQUASH */
    /* Offset 0 gives the best switch position.  */
    switch (*name++) {
    case 'R':
      if (memEQ(name, "EWORD", 5)) {
      /*                R           */
#ifdef REWORD
        *iv_return = REWORD;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'S':
      if (memEQ(name, "QUASH", 5)) {
      /*                S           */
#ifdef SQUASH
        *iv_return = SQUASH;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

