#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
_stash_progress_constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl5.34.0 -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(ANALYZE_INDEX ANALYZE_MODIFIED ANALYZE_UNTRACKED
	       CHECKOUT_MODIFIED CHECKOUT_UNTRACKED DONE LOADING_STASH NONE));

print constant_types(), "\n"; # macro defs
foreach (C_constant ("Git::Raw::Stash::Progress", '_stash_progress_constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("Git::Raw::Stash::Progress", $types);
__END__
   */

  switch (len) {
  case 4:
    /* Names all of length 4.  */
    /* DONE NONE */
    /* Offset 0 gives the best switch position.  */
    switch (*name++) {
    case 'D':
      if (memEQ(name, "ONE", 3)) {
      /*                D         */
#ifdef DONE
        *iv_return = DONE;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'N':
      if (memEQ(name, "ONE", 3)) {
      /*                N         */
#ifdef NONE
        *iv_return = NONE;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 13:
    /* Names all of length 13.  */
    /* ANALYZE_INDEX LOADING_STASH */
    /* Offset 1 gives the best switch position.  */
    switch (name[1]) {
    case 'N':
      if (memEQ(name, "ANALYZE_INDEX", 13)) {
      /*                ^                  */
#ifdef ANALYZE_INDEX
        *iv_return = ANALYZE_INDEX;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'O':
      if (memEQ(name, "LOADING_STASH", 13)) {
      /*                ^                  */
#ifdef LOADING_STASH
        *iv_return = LOADING_STASH;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 16:
    if (memEQ(name, "ANALYZE_MODIFIED", 16)) {
#ifdef ANALYZE_MODIFIED
      *iv_return = ANALYZE_MODIFIED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 17:
    /* Names all of length 17.  */
    /* ANALYZE_UNTRACKED CHECKOUT_MODIFIED */
    /* Offset 9 gives the best switch position.  */
    switch (name[9]) {
    case 'M':
      if (memEQ(name, "CHECKOUT_MODIFIED", 17)) {
      /*                        ^              */
#ifdef CHECKOUT_MODIFIED
        *iv_return = CHECKOUT_MODIFIED;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'N':
      if (memEQ(name, "ANALYZE_UNTRACKED", 17)) {
      /*                        ^              */
#ifdef ANALYZE_UNTRACKED
        *iv_return = ANALYZE_UNTRACKED;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 18:
    if (memEQ(name, "CHECKOUT_UNTRACKED", 18)) {
#ifdef CHECKOUT_UNTRACKED
      *iv_return = CHECKOUT_UNTRACKED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

